/***************************************************************************
 *   Copyright (C) 2007 by Michał Gacek   *
 *   admin@flynet.com.pl   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <mysql++.h>
#include <rude/config.h>
#include <iomanip>
#include <iostream>
#include <string>
#include <vector>
#include <fstream>
#include <sys/types.h>
#include <sys/stat.h>

using namespace std;
using namespace mysqlpp;
using namespace rude;

Connection con(use_exceptions);
//mysqlpp::Connection con(false);
Query query = con.query();
Query query_update = con.query();
vector<string> yy;

string workdir = "/etc/lms/";
string conffile = workdir + "conf/lms.conf";
string mt_tmp = workdir + "tmp/warnings_mt";
vector<string> mem;
vector<string> fcore;
int y = 0;


static ostream&
separator(ostream& os)
{
	os << endl << "---------------------------" << endl << endl;
	return os;
}


static ostream&
make_ffooter(ostream& os)
{
  os << "expect \"\\>\"" << endl <<"send -- \"quit\\r\"" << endl << "expect eof";
  return os;
}
void sm(string st)
{
  string w;
  w = "expect \">\"\n";
  w = w + "send -- \"" + st + "\\r\"" + "\n";
  w = w + "expect \"\\r\"" + "\n";
  w = w + "send -- \"\\r\"" + "\n";
  fcore.push_back(w);
  //  cout << endl  << fcore.size() << endl;
}


string plural (int a, string b)
{
  // vector<string> *name;
  //string michal = "test";
  //name = &michal;
  
  string *plural;
  vector<string> device; 
  device.push_back(" urządzenia:");
  device.push_back(" urządzeń:");
  vector<string> operation;
  operation.push_back(" operacje:");
  operation.push_back(" operacji:");
  if(b == "device")
    {
      if(a>1) 
	plural = &device[1];
      else
	plural = &device[0];
    }
  if(b == "operation")
    {
      if(a>4) 
	plural = &operation[1];
      else
	plural = &operation[0];
    }

  
  return *plural;
}

string make_fheader(string mt_ip, string mt_pass, string mt_user = "admin")
{
  string w;
  w = "#!/usr/bin/expect -f\n";
  w = w + "set force_conservative 0\n";
  w = w + "if {$force_conservative} {\n";
  w = w + "set send_slow {1 .1}\n";
  w = w + "proc send {ignore arg} {\n";
  w = w + "sleep .1\n";
  w = w + "exp_send -s -- $arg\n";
  w = w + "}\n";
  w = w + "}\n";
  w = w + "set timeout -1\n";
  w = w + "spawn ssh " + mt_user + "@" + mt_ip + "\n";
  w = w + "match_max 100000\n";
  w = w + "expect \"password:\"\n";
  w = w + "send -- \"" + mt_pass + "\\r\"\n";
  return w;
}



int help()
{
  cout << "warnings v0.9,  Copyright FlyNet s.c." << endl << "Usage: warnings [module [switch ip]]" << endl << endl <<
    "Modules:" << endl << "normal     --    Run through LMS database and make changes to\n                 warnings/access system" << endl; 
  cout << "warnings   --    Manage warnings manually, needed options are\n                 enable/disable switch and an ip address" << endl;
  cout << "access     --    Manage access to www sites manually, needed options\n                 are enable/disable switch and an ip address" << endl;
  exit(1); 
}


int warnings_enable()
{
  query << "select INET_NTOA(ipaddr) as ip, name from nodes where warning=1 and warningchk=0";
  //cout << "Query: " << query.preview() << endl << endl;
	Result res = query.store();
	Row row;
	Result::iterator i;
	volatile MYSQL_RES* ress = res.raw_result();
	if (!ress)
	  return -1;
	if (res.size()>0)
	  {
	    int x = 0;
	    string devices = "    ";
	    string which;
	    for (i = res.begin(); i != res.end(); ++i) 
	      {
		row = *i;
		sm("/ip firewall nat add chain=dstnat src-address=" + row["ip"].get_string() + " protocol=tcp dst-port=80 action=dst-nat to-addresses=10.10.0.8 to-ports=3128 comment=wiadomosc");
		query_update.execute("warningchk", "1", row["ip"].get_string());
		devices=devices + "  " + row["name"].get_string();
		//	query_update.reset();
		//x = *i;
		x++;
		which="device";
	      }
	    cout << " * Włączam ostrzeżenia dla " << x << plural(x, "device") <<endl << devices << endl;
	    y=y+x;
	    query.reset();
	  }
}







int warnings_disable()
{
  query << "select INET_NTOA(ipaddr) as ip, name from nodes where warning=0 and warningchk=1";
  //cout << "Query: " << query.preview() << endl << endl;
  Result res = query.store();
  Row row;
  Result::iterator i;
  volatile MYSQL_RES* ress = res.raw_result();
  if (!ress)
    return -1;
  if (res.size()>0)
    {
      string devices = "   ";
      int x = 0;
      for (i = res.begin(); i != res.end(); ++i) 
	{
	  row = *i;
	  sm("/ip firewall nat remove\\[/ip firewall nat find comment=wiadomosc src-address=" + row["ip"].get_string() + "\\]");
	  query_update.execute("warningchk", "0", row["ip"].get_string());
	  devices=devices + "  " + row["name"].get_string();
	  x++;
	}
      cout << " * Wyłączam ostrzeżenia dla " << x << plural(x, "device") << endl << devices << endl;
      y=y+x;
      query.reset();
    } 	
}



int access_enable()
{
  query << "select INET_NTOA(ipaddr) as ip, name from nodes where access=1 and accesschk=1";
  //cout << "Query: " << query.preview() << endl << endl;
  Result res = query.store();
  Row row;
  Result::iterator i;
  volatile MYSQL_RES* ress = res.raw_result();
  if (!ress)
    return -1;
  if (res.size()>0)
    {
      int x=0;
      string devices="    ";
      for (i = res.begin(); i != res.end(); ++i) 
	{
	  row = *i;
	  sm("/ip firewall nat remove\\[/ip firewall nat find comment=denyaccess src-address=" + row["ip"].get_string() + "\\]");
	  query_update.execute("accesschk", "0", row["ip"].get_string());
	  devices=devices + "  " + row["name"].get_string();
	  x++;
	}
      cout << " * Włączam dostęp do www dla " << x << plural(x, "device") << endl << devices << endl;
      y=y+x;
      query.reset();
    } 	
}


int access_disable()
{
  query << "select INET_NTOA(ipaddr) as ip, name from nodes where access=0 and accesschk=0";
  //cout << "Query: " << query.preview() << endl << endl;
  Result res = query.store();
  Row row;
  Result::iterator i;
  volatile MYSQL_RES* ress = res.raw_result();
  if (!ress)
    return -1;
  if (res.size()>0)
    {
      int x=0;
      string devices = "    ";
      for (i = res.begin(); i != res.end(); ++i) 
	{
	  row = *i;
	  sm("/ip firewall nat add chain=dstnat src-address=" + row["ip"].get_string() + " protocol=tcp dst-port=80 action=dst-nat to-addresses=10.10.0.8 to-ports=3128 comment=denyaccess");
	  query_update.execute("accesschk", "1", row["ip"].get_string());
	  devices=devices + "  " + row["name"].get_string();
	  //	query_update.reset();
	  x++;
	}
      cout << " * Wyłączam dostęp do www dla " << x << plural(x, "device") << endl << devices << endl;
      y=y+x;
      query.reset();
    }
}


int save()
{
  //save config and execute expect scripts
  //  Query query = con.query();
  string s = "%Border Gateway%";
  query << "select  INET_NTOA(nodes.ipaddr) as ip, nodes.passwd as passwd, nodes.name as name from netdevices, nodes where netdevices.id=nodes.netdev and netdevices.description LIKE " << quote_only << s << " group by netdevices.id";
  //cout << "Query: " << query.preview() << endl << endl;
  Result res = query.store();
  Row row;
  Result::iterator i;
  //
  volatile MYSQL_RES* ress = res.raw_result();
  if (!ress)
    return -1;
  ofstream file;
  for (i = res.begin(); i != res.end(); ++i) 
    {
      row = *i;
      string filename = mt_tmp + "-" + row["ip"].get_string();
      file.open (filename.c_str()); 	    
      file << make_fheader(row["ip"].get_string(), row["passwd"].get_string());
      for(int i = 0; i < fcore.size(); i++)
	{
	  file <<  fcore[i];
	}
      file << make_ffooter;
      file << endl;
      file.close();
      chmod(filename.c_str(), 777);
      filename = filename + " >> /etc/lms/logs/warnings.log &";
      //cout << "zmienna: \"" << filename.c_str() << "\"" << endl;
      system(filename.c_str());
    }
  return 0;
}

int warnenable(string ip)
{
  //cout << "wylaczam" << ip << endl;
  sm("/ip firewall nat add chain=dstnat src-address=" + ip + " protocol=tcp dst-port=80 action=dst-nat to-addresses=10.10.0.8 to-ports=3128 comment=wiadomosc");
  save();
  return 0;
}

int accessdisable(string ip)
{
  //cout << "wylaczam" << ip << endl;
  sm("/ip firewall nat add chain=dstnat src-address=" + ip + " protocol=tcp dst-port=80 action=dst-nat to-addresses=10.10.0.8 to-ports=3128 comment=accessdeny");
  save();
  return 0;
}

int warndisable(string ip)
{
  //cout << "wylaczam" << ip << endl;
  sm("/ip firewall nat remove\\[/ip firewall nat find comment=wiadomosc src-address=" + ip + "\\]");
  save();
  return 0;
}


int accessenable(string ip)
{

  sm("/ip firewall nat remove\\[/ip firewall nat find comment=accessdeny src-address=" + ip + "\\]");
  save();
  return 0;
}











int main(int argc, char *argv[])
{
  
  // create an empty vector of strings
  vector<string> args;
  // copy program arguments into vector
  

// disable(args[2]);
// 	      exit(1);
// 	    }
// 	  else
// 	    {
// 	      cout << "musisz podac adres ip!!" << endl;
// 	      exit(1);
// 	    }
// 	}
//       if (args[1] == "enable")
// 	{
// 	  if(argc>2)
// 	    {
// 	      disable(args[2]);
// 	      exit(1);
// 	    }
// 	  else
// 	    {
// 	      cout << "musisz podac adres ip!!" << endl;
// 	      exit(1);
// 	    }  
// 	}
//     }
  
  
  try {
    const char* dbhost;
    const char* dbuser;
    const char* dbpass;
    Config config;
    if(config.load(conffile.c_str()))
      {
	config.setSection("warnings");
	dbhost = config.getStringValue("dbhost");
	dbuser = config.getStringValue("dbuser");
	dbpass = config.getStringValue("dbpass");
      }
    
    con.connect("lms",dbhost,dbuser,dbpass);
    if(!con)
      {
	printf("Unable to connect to database.\n");
	exit (1);
      }
    if(argc>1)
    {
      int i;
      for (i=0;i<argc;i++)
	{ 
	  args.push_back(argv[i]);
	}
      if (args[1] == "warnings")
	{
	  if(argc>2)
	    {
	      if (args[2] == "enable")
		{
		  if(argc>3)
		    {
		      warnenable(args[3]);
		      //      save();
		      exit(1);
		    }
		  else
		    help();
		}
	      if (args[2] == "disable")
		{
		  if(argc>3)
		    {
		      warndisable(args[3]);
		      exit(1);
		    }
		  else
		    help();
		}
	    }
	  else
	    help();
	}
      if (args[1] == "access")
	{
	  if(argc>2)
	    {
	      if (args[2] == "enable")
		{
		  if(argc>3)
		    {
		      accessenable(args[3]);
		      exit(1);
		    }
		  else
		    help();
		}
	      if (args[2] == "disable")
		{
		  if(argc>3)
		    {
		      accessdisable(args[3]);
		      exit(1);
		    }
		  else
		    help();
		}
	    }
	  else
	    help();
	}
      if (args[1] != "normal")
	  help();
    }
  else
    help();

    





    //normal mode
    cout << "Przeładowuję ostrzeżenia i dostęp do www:" <<endl;
    query_update << "update nodes set %0"" = %1q where INET_NTOA(ipaddr) = %2q";
    query_update.parse();
     
    warnings_enable();
    warnings_disable();
    access_enable();
    access_disable();


    if (y == 0)
      {
	cout << "Nie było nic do przeładowania" << endl;
	exit(1);
      }
    else
      {
	cout << "Pomyślnie wykonano " << y << plural(y, "operation") << endl;
	save();
      }
  }

  //mysql error logging
  catch (const BadQuery& er) 
    {
      // Handle any query errors
      cerr << "Query error: " << er.what() << endl;
      return -1;
    }
  catch (const BadConversion& er) 
    {
      // Handle bad conversions
      cerr << "Conversion error: " << er.what() << endl <<
	"\tretrieved data size: " << er.retrieved <<
	", actual size: " << er.actual_size << endl;
      return -1;
    }
  catch (const Exception& er) 
    {
      // Catch-all for any other MySQL++ exceptions
      cerr << "Error: " << er.what() << endl;
      return -1;
    }

  return 0;
}




